"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const R = __importStar(require("ramda"));
const events_1 = require("./events");
exports.debugSetOrderEvent = (value) => [
    'Setting order %s.',
    value.id,
];
exports.debugRemoveOrderEvent = (value) => [
    'Removing order %s.',
    value.id,
];
exports.debugSnapshotEvent = (value) => [
    'Snapshot with %s orders (bids and asks).',
    value.orders.length,
];
exports.eventToMessageFragments = R.cond([
    [events_1.isSetOrderEvent, exports.debugSetOrderEvent],
    [events_1.isRemoveOrderEvent, exports.debugRemoveOrderEvent],
    [events_1.isSnapshotEvent, exports.debugSnapshotEvent],
    [R.T, (...value) => [...value]],
]);
exports.debugEvent = R.curryN(2, (debug, value) => {
    const fragments = exports.eventToMessageFragments(value);
    debug(...fragments);
});
