"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("../../types");
const token_math_1 = require("@melonproject/token-math");
exports.normalizeOrder = (options, order) => {
    const [id, price, amount] = order;
    const key = `${types_1.Exchange.ETHFINEX}:${id}`;
    const volume = Math.abs(amount);
    return {
        id: Buffer.from(key).toString('base64'),
        type: amount > 0 ? types_1.OrderType.BID : types_1.OrderType.ASK,
        exchange: types_1.Exchange.ETHFINEX,
        trade: token_math_1.createPrice(token_math_1.createQuantity(options.pair.base, volume), token_math_1.createQuantity(options.pair.quote, price * volume)),
    };
};
