"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Rx = __importStar(require("rxjs"));
const operators_1 = require("rxjs/operators");
const types_1 = require("../../types");
const debug_1 = require("../../debug");
const fetch_1 = require("./fetch");
const debug = require('debug')('exchange-aggregator:kraken');
const createSnapshot = (orders) => ({
    event: types_1.NormalizedMessageType.SNAPSHOT,
    exchange: types_1.Exchange.KRAKEN,
    orders,
});
exports.watch = (options) => {
    const interval = options.interval || 5000;
    const polling$ = Rx.interval(interval).pipe(operators_1.switchMap(() => fetch_1.fetch(options)), operators_1.catchError(error => {
        debug('Error while trying to fetch: %s.', error);
        return Rx.throwError(error);
    }), operators_1.retryWhen(error => {
        debug('Caught error. Retrying in %s miliseconds.', interval);
        return error.pipe(operators_1.delay(interval));
    }), operators_1.distinctUntilChanged());
    return polling$.pipe(operators_1.map(createSnapshot), operators_1.tap(debug_1.debugEvent(debug)));
};
