"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Rx = __importStar(require("rxjs"));
const operators_1 = require("rxjs/operators");
const types_1 = require("../../types");
const debug_1 = require("../../debug");
const fetch_1 = require("./fetch");
const debug = require('debug')('exchange-aggregator:kyber');
const createSnapshot = (orders) => ({
    event: types_1.NormalizedMessageType.SNAPSHOT,
    exchange: types_1.Exchange.KYBER_NETWORK,
    orders,
});
const pollRate = (options, currencies) => {
    const base = options.pair.base.symbol;
    const quote = options.pair.quote.symbol;
    return Rx.interval(5000).pipe(operators_1.tap(() => {
        debug(`Loading snapshot for market %s-%s.`, base, quote);
    }), operators_1.switchMap(() => fetch_1.fetchRates(options, currencies)), operators_1.retryWhen(error => error.pipe(operators_1.delay(10000))), operators_1.distinctUntilChanged());
};
exports.watch = (options) => {
    const rates$ = Rx.from(fetch_1.fetchCurrencies(options)).pipe(operators_1.retryWhen(error => error.pipe(operators_1.delay(10000))), operators_1.switchMap(currencies => pollRate(options, currencies)));
    return rates$.pipe(operators_1.map(createSnapshot), operators_1.tap(debug_1.debugEvent(debug)));
};
